package de.fhdw.gaming.memory.impl;

import java.util.Optional;
import java.util.Set;

import de.fhdw.gaming.core.domain.Game;
import de.fhdw.gaming.core.domain.Move;
import de.fhdw.gaming.core.domain.Observer;
import de.fhdw.gaming.core.domain.Player;
import de.fhdw.gaming.core.domain.State;

/**
 * An observer implementation that interacts with the memory brain to remember game outcomes.
 */
public class MemoryObserverImpl implements Observer {

    @Override
    public void started(Game<?, ?, ?, ?> game, State<?, ?> state) throws InterruptedException {
        // Not implemented
    }

    @Override
    public void nextPlayersComputed(Game<?, ?, ?, ?> game, State<?, ?> state, Set<? extends Player<?>> players)
            throws InterruptedException {
        // Not implemented
    }

    @Override
    public void illegalPlayerRejected(Game<?, ?, ?, ?> game, State<?, ?> state, Player<?> player)
            throws InterruptedException {
        // Not implemented
    }

    @Override
    public void legalMoveApplied(Game<?, ?, ?, ?> game, State<?, ?> state, Player<?> player, Move<?, ?> move)
            throws InterruptedException {
        // Not implemented
    }

    @Override
    public void illegalMoveRejected(Game<?, ?, ?, ?> game, State<?, ?> state, Player<?> player,
            Optional<Move<?, ?>> move, String reason) throws InterruptedException {
        // Not implemented
    }

    @Override
    public void overdueMoveRejected(Game<?, ?, ?, ?> game, State<?, ?> state, Player<?> player,
            Optional<Move<?, ?>> chosenMove) throws InterruptedException {
        // Not implemented
    }

    @Override
    public void playerResigned(Game<?, ?, ?, ?> game, State<?, ?> state, Player<?> player) throws InterruptedException {
        // Not implemented
    }

    @Override
    public void playerOvertaken(Game<?, ?, ?, ?> game, State<?, ?> state, Player<?> overtakenPlayer,
            Player<?> overtakingPlayer) throws InterruptedException {
        // Not implemented
    }

    /**
     * Every time a game finished the outcome will be remembered by the brain.
     */
    @Override
    public void finished(Game<?, ?, ?, ?> game, State<?, ?> state) throws InterruptedException {
        MemoryBrainImpl.getInstance().rememberOutcome(game);
    }

}
